#ifndef _EDMA_DRV_H
#define _EDMA_DRV_H

#include <stdio.h>
#include <xdc/std.h>
#include <ti/sysbios/knl/Task.h>
#include <ti/sysbios/knl/Semaphore.h>

/* Include EDMA3 Driver */
#include <ti/sdo/edma3/drv/sample/bios6_edma3_drv_sample.h>
#include "VpcTypes.h"

#ifdef __cplusplus
extern "C" {
#endif

/* To enable/disable the cache .*/
//#define EDMA3_ENABLE_DCACHE                 (1u)

#define STREAM_CHANNEL_MAX  100                  //OBS must always be an even number
extern uint32  StreamingBuff[STREAM_CHANNEL_MAX];

/**
 * EDMA3 Driver Handle, which is used to call all the Driver APIs.
 * It gets initialized during EDMA3 Initialization.
 */
extern EDMA3_DRV_Handle hEdma[];

extern signed char*  getGlobalAddr(signed char* addr);

#define MAX_NUM_EDMA_INSTANCES  5
#define TRIG_STREAMING trig_qDma_Streaming

extern unsigned int ToPPCStreamingQDMAFirstHalf;
extern unsigned int ToPPCStreamingQDMASecHalf;

#define GLOBAL_ADDR(addr) (getGlobalAddr(addr))

extern EDMA3_DRV_Result enable_edma_chain(void);
extern EDMA3_DRV_Result trig_qDma_Y(void);
extern EDMA3_DRV_Result trig_qDma_X(void);
extern EDMA3_DRV_Result trig_qDma_Streaming(unsigned int *chId);
extern EDMA3_DRV_Result trig_Dma_DPRAM(volatile int16* dst, const int16* src, uint32 size);

extern void low_level_edma_initialize (void);

#ifdef __cplusplus
}
#endif /* extern "C" */

#endif  /* _EDMA_DRV_H */

